

-- this file manages the carpet selector window
integer CARPET CARPET = 0

constant
	SAMPLE_WIDTH = 69,
	SAMPLE_HEIGHT = 59,
	SAMPLE_ACROSS = 5,
	SAMPLE_DOWN = 6
	
integer Owner Owner = 0

integer PALETTE PALETTE = 0

integer SampleNumber SampleNumber = 0

integer dib dib = 0


procedure makeCarpetPalette()
	PALETTE = loadDibImage( getAppDir() & "\\palette\\carpet.bmp" )
		
	end procedure

makeCarpetPalette()


global function getCarpetDib()
	if SampleNumber and dib then
		return dib
	end if
	return 0
	end function

global function getCarpetSample()
	return SampleNumber
	end function

procedure displayCarpet(atom dc)
	if PALETTE then
		copyDibToDC(dc, 0 , 0, PALETTE)
	end if
	end procedure


procedure drawCarpet()
	integer dib_x, dib_y

	if not SampleNumber then
		return
	end if

	-- calc palette coords
	dib_x = remainder((SampleNumber-1), SAMPLE_ACROSS) * SAMPLE_WIDTH
	dib_y = floor((SampleNumber-1) / SAMPLE_ACROSS) * SAMPLE_HEIGHT

	-- loop
	for x = 0 to getDibWidth(dib) by SAMPLE_WIDTH do
		for y = 0 to getDibHeight(dib) by SAMPLE_HEIGHT do
			stretchDibToDib(
				dib, x, y, SAMPLE_WIDTH, SAMPLE_HEIGHT,
				PALETTE, dib_x, dib_y, SAMPLE_WIDTH, SAMPLE_HEIGHT)
		end for
	end for

	end procedure


global procedure resizeCarpetWidth(integer width)
	if dib then
		void = deleteDib(dib)
	end if
	dib = createDib(width, 200, 32)
	drawCarpet()
	end procedure


procedure selectCarpetSample(sequence lParam)
	integer x, y, sample_number
	
	x = lParam[1]
	y = lParam[2]

	if x > 0 and x < getDibWidth(PALETTE) and y>0 and y < getDibHeight(PALETTE) then

		sample_number = 1 + floor(x/SAMPLE_WIDTH) + floor(y/SAMPLE_HEIGHT)*SAMPLE_ACROSS

		if SampleNumber != sample_number then
			SampleNumber = sample_number
			drawCarpet()
			invalidateRect(Owner, 0)

		end if

	end if

	end procedure

function getWinWidth()
	integer w
	w = 200
	if PALETTE then
		w = getDibWidth(PALETTE) + 7
	end if
	return w
	end function

function getWinHeight()
	integer h
	h = 200
	if PALETTE then
		h = getDibHeight(PALETTE) + 25
	end if
	return h
	end function

function handler_CARPET(integer id, integer msg, atom wParam, object lParam)
	object file
	integer x, y

	if PALETTE then

		if msg = WM_LBUTTONDOWN and PALETTE then
			selectCarpetSample(lParam)

		elsif msg = WM_PAINT then
			displayCarpet(wParam)

		elsif msg = WM_KEYDOWN then
			return sendMessage(1, msg, wParam, lParam)

		elsif msg = WM_SIZING then
			lParam [3] = lParam [1] + getWinWidth()
			lParam [4] = lParam [2] + getWinHeight()
			return lParam

		end if

	end if

	return 0

	end function


global procedure createCarpetSelector(integer owner)
	sequence text
	Owner = owner
	text = "Carpet Selector"
	if not PALETTE then
		text = "Couldn't find \"Carpet.bmp\""
	end if
	CARPET = create(Window, text, 0, owner, 400,30,getWinWidth(),getWinHeight(),{0,WS_EX_TOOLWINDOW})
	setHandler( CARPET, routine_id("handler_CARPET"))
	setVisible(CARPET, 0)
	end procedure

global procedure openCarpetSelector()
	setVisible(CARPET, 1)
	end procedure