

-- this file manages the grout colour selector window
integer COLOUR COLOUR = 0
integer GroutColour GroutColour = #888888

global function getGroutColour()
	return GroutColour
	end function

integer Owner Owner = 0

integer PALETTE PALETTE = 0

procedure makePalette()
	PALETTE = loadDibImage( getAppDir() & "\\palette\\grout.bmp" )
	end procedure

makePalette()

procedure displayColour(atom dc)
	if PALETTE then
		copyDibToDC(dc, 0 , 0, PALETTE)
	end if
	end procedure




function getWinWidth()
	integer w
	w = 350
	if PALETTE then
		w = getDibWidth(PALETTE) + 7
	end if
	return w
	end function

function getWinHeight()
	integer h
	h = 200
	if PALETTE then
		h = getDibHeight(PALETTE) + 25
	end if
	return h
	end function

function handler_COLOUR(integer id, integer msg, atom wParam, object lParam)
	object file
	integer x, y

	if PALETTE then
		if msg = WM_LBUTTONDOWN then
			x = lParam[1]
			y = lParam[2]
			if x > 0 and x < getDibWidth(PALETTE) and y>0 and y < getDibHeight(PALETTE) then
				GroutColour = getDibPixel(PALETTE, x, y)
				changeModel_groutcolour(GroutColour)
				invalidateRect(Owner, 0)
			end if

		elsif msg = WM_PAINT then
			displayColour(wParam)

		elsif msg = WM_KEYDOWN then
			return sendMessage(1, msg, wParam, lParam)

		elsif msg = WM_SIZING then
			lParam [3] = lParam [1] + getWinWidth()
			lParam [4] = lParam [2] + getWinHeight()
			return lParam

		end if

	end if

	return 0

	end function

global procedure createGroutSelector(integer owner)
	integer w, h
	sequence text
	w = 350
	h = 200
	if PALETTE then
		w = getDibWidth(PALETTE) + 10
		h = getDibHeight(PALETTE) + 25
	end if
	Owner = owner
	text = "Grout Colour Selector"
	if not PALETTE then
		text = "Couldn't find \"Grout.bmp\""
	end if
	COLOUR = create(Window, text, 0, owner, 400,30,getWinWidth(),getWinHeight(),{0,WS_EX_TOOLWINDOW})
	setHandler( COLOUR, routine_id("handler_COLOUR"))
	setVisible(COLOUR, 0)
	end procedure

global procedure openGroutSelector()
	setVisible(COLOUR, 1)
	end procedure