

integer Dib Dib = 0


-- SIZE OF TILES
constant TILESIZES = {75, 100, 150, 200, 250, 300}
integer TilePtr TilePtr = 2

global function getTileSize()
	return TILESIZES[TilePtr]
	end function

function changeTileSize(integer inc_dec)
	integer tmp
	tmp = TilePtr
	TilePtr += inc_dec
	if TilePtr > length(TILESIZES) then
		TilePtr = length(TILESIZES)
	elsif TilePtr < 1 then
		TilePtr = 1
	end if 
	return tmp != TilePtr
	end function

-- SIZE OF FLOOR AREA
constant FLOORWIDTHS = {400, 500, 600, 700, 800, 900}
constant FLOORHEIGHTS= {200, 300, 400, 500, 600, 700}
integer FloorPtr FloorPtr = 3

global function getFloorWidth()
	return FLOORWIDTHS[FloorPtr]
	end function


global function getFloorHeight()
	return FLOORHEIGHTS[FloorPtr]
	end function


function changeFloorSize(integer inc_dec)
	integer tmp
	tmp = FloorPtr
	FloorPtr += inc_dec
	if FloorPtr > length(FLOORWIDTHS) then
		FloorPtr = length(FLOORWIDTHS)
	elsif FloorPtr < 1 then
		FloorPtr = 1
	end if
	return tmp != FloorPtr
	end function


-- GROUT SPECS
integer GroutColour, GroutPtr
constant GROUTSIZES = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 12, 14, 17, 20}
GroutPtr = 3
GroutColour = #888888

global function getGroutWidth()
	return GROUTSIZES[GroutPtr]
	end function

function changeGroutSize(integer inc_dec)
	integer tmp
	tmp = GroutPtr
	GroutPtr += inc_dec
	if GroutPtr > length(GROUTSIZES) then
		GroutPtr = length(GROUTSIZES)
	elsif GroutPtr < 1 then
		GroutPtr = 1
	end if 
	return tmp != GroutPtr
	end function



-- TILE PATTERNS
integer TilePattern
--global constant // from pattern.e
-- 	PATTERN_STACK = 1,
--	PATTERN_BLOCK = 2,
--	PATTERN_RECUADRO = 3,
--	PATTERN_CRISSCROSS = 4
TilePattern = PATTERN_STACK

constant PATTERNS = {PATTERN_STACK, PATTERN_BLOCK, PATTERN_RECUADRO, PATTERN_CRISSCROSS}

global function getModelDib()
	return Dib
	end function

global function changeTilePattern(integer new)
	if not find(new, PATTERNS) then
		return 0
	end if
	TilePattern = new
	return 1
	end function

------------------------------------
procedure recreateDib()
	if Dib then
		void = deleteDib(Dib)
	end if
	Dib = createDib(getFloorWidth(), getFloorHeight(), 32)
	end procedure


global procedure drawModel()
	sequence coords, orients
	integer kind, id, x, y
	coords = getPattern()
	orients = getOrientations()
	setText(1, "Tile Model: " & getOrientDesc())
	for i = 1 to length(coords) do
		x = coords[i][1]
		y = coords[i][2]
		id = getTileForOrientation(orients[i])
		copyDibToDib(Dib, x, y, id)
	end for
	end procedure	
	

procedure makeModel()
	void = makeFourTileOrientations(getTileSize(), getGroutWidth(), GroutColour)
	changePattern(getFloorWidth(), getFloorHeight(), TilePattern)
	recreateDib()
	drawModel()
	end procedure


global function loadModel(sequence fName)
	if loadTileBitmap(fName) then
		resetOrientation()
		TilePattern = PATTERN_STACK
		makeModel()
		resizeCarpetWidth(getDibWidth(Dib))
		return 1
	end if
	return 0
	end function


	
global procedure rebuildModel()
	-- rebuild model but do not need to reload it
	if isTileLoaded() then
		makeModel()
	end if
	end procedure


global procedure changeModel_floorsize(integer inc_dec)
	if	changeFloorSize(inc_dec) then
		rebuildModel()
	end if
	end procedure


global procedure changeModel_tilesize(integer inc_dec)
	if changeTileSize(inc_dec) then
		rebuildModel()
	end if
	end procedure


global procedure changeModel_groutsize(integer inc_dec)
	if changeGroutSize(inc_dec) then
		rebuildModel()
	end if
	end procedure


global procedure changeModel_groutcolour(integer new_colour)
--	integer r,g,b
--	-- first, convert the colour to rgb
--	b = and_bits(new_colour, 255)
--	g = floor( and_bits(new_colour, #FF00)/256)
--	r = floor(new_colour/65536)
--
--	new_colour = r + g*256 + b*65536
	
	GroutColour = new_colour
	rebuildModel()
	end procedure


global procedure changeModel_pattern(integer pattern)
	if changeTilePattern(pattern) then
		rebuildModel()
	end if
	end procedure